﻿--[[
    Author: Valana <Ridiculously Beautiful> of Magtheridon Horde-US
]]

local TbAntiDaze = LibStub("AceAddon-3.0"):NewAddon("TbAntiDaze", "AceEvent-3.0")

local bband = bit.band

local _me = bit.bor(COMBATLOG_OBJECT_AFFILIATION_MINE, COMBATLOG_OBJECT_TYPE_PLAYER)
local _group = bit.bor(COMBATLOG_OBJECT_AFFILIATION_MINE, COMBATLOG_OBJECT_AFFILIATION_PARTY, COMBATLOG_OBJECT_AFFILIATION_RAID)
local _cheetah = GetSpellInfo(5118)
local _pack = GetSpellInfo(13159)


function TbAntiDaze:OnEnable()
    -- Only enable this addon if the player is a hunter of an appropriate level.
    local _, class = UnitClass("player")
    if class == "HUNTER" and UnitLevel("player") > 15 then
        self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    end
end

function TbAntiDaze:COMBAT_LOG_EVENT_UNFILTERED(e, timestamp, event, sourceGuid, sourceName, sourceFlags, destinationGuid, destinationName, destinationFlags, spellId, spellName, ...)
    -- Filter out combat log events we are not interested in.
    if spellId ~= 15571 or bband(destinationFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) == 0 or (event ~= "SPELL_AURA_APPLIED" and event ~= "SPELL_AURA_REFRESH") then return end

    -- Produce a warning if Aspect of the Cheetah got us dazed.
    if bband(destinationFlags, _me) == _me then
    end

    -- Produce a warning if Aspect of the Pack got a group member dazed.
    if bband(destinationFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) == COMBATLOG_OBJECT_AFFILIATION_MINE or bband(destinationFlags, _group) ~= 0 then
    end
end
